#!/bin/bash

# updated by WIPAT 2555-02-14
# usage: sh get-pc-usage.sh option START_DATE(YYYY/MM/DD) END_DATE(YYYY/MM/DD)
# option= -ip or -mac or -user and/or without -period
# sample: sh get-pc-usage.sh -ip 2012/01/11 2012/02/13
# sample: sh get-pc-usage.sh -user -period 2012/01/11 2012/02/13

KEY="txt"
DIR="/tmp/mytest"
START=""
STOP=""
MODE="USER"
PERIOD=""

for ID in "$@" ; do
  OPTION=$(echo "${ID}"|cut -c 1-2) 
  case "${OPTION}" in
   -[iI]) MODE="IP"; continue ;;
   -[mM]) MODE="MAC"; continue ;;
   -[uU]) MODE="USER"; continue ;;
   -[pP]) PERIOD="YES"; continue ;;
  esac
  if [ -z "${START}" ] ; then
    START=${ID}
  else
    STOP=${ID}
  fi
done
if [ -z "${START}" ] ; then
  START=$(date "+%Y/%m/%d")
fi
if [ -z "${STOP}" ] ; then
  STOP=$(date "+%Y/%m/%d")
fi

mkdir -p "${DIR}"
rm -rf "${DIR}/*"

END=$(echo "${STOP}"|sed "s;/;;g")
MYDATE="${START}"
NOW=$(echo "${MYDATE}"|sed "s;/;;g")
while [ ${NOW} -le ${END} ] ; do
  MYDATE=$(date -d "${MYDATE} +1 day" "+%Y/%m/%d")
  NOW=$(echo "${MYDATE}"|sed "s;/;;g")
# for local /var/www/ticker/datalog
  SRC="/var/www/ticker/datalog/${MYDATE}"
  find ${SRC} -type f|grep "${KEY}"|while read LINE;do cp ${LINE} ${DIR};done
# for network http://myserver.domain/ticker/datalog
  URL="http://myserver.domain/ticker/datalog/${MYDATE}"
#  wget -r -l1 -nd -np -A ".txt" -P ${DIR} ${URL} 
done

if [ "${MODE}" = "USER" ] ; then
  echo "START=${START} END=${STOP} Username,Time in seconds"
  if [ -z "${PERIOD}" ] ; then
    cat ${DIR}/*.txt|awk -F: '{val[$5]+=$9} END {for(id in val) print id","val[id]}'|sort -t','
  else
    cat ${DIR}/*.txt|awk -F: '{val[$5]+=$9} END {for(id in val) print id","val[id]}'|sort -t',' -n -r -k 2
  fi
fi
if [ "${MODE}" = "MAC" ] ; then
  echo "START=${START} END=${STOP} ,Time in seconds"
  if [ -z "${PERIOD}" ] ; then
    cat ${DIR}/*.txt|awk -F: '{val[$3]+=$9} END {for(id in val) print id","val[id]}'|sort -t','
  else
    cat ${DIR}/*.txt|awk -F: '{val[$3]+=$9} END {for(id in val) print id","val[id]}'|sort -t',' -n -r -k 2
  fi
fi
if [ "${MODE}" = "IP" ] ; then
  echo "START=${START} END=${STOP} IP address,Time in seconds"
  if [ -z "${PERIOD}" ] ; then
    cat ${DIR}/*.txt|awk -F: '{val[$4]+=$9} END {for(id in val) print id","val[id]}'|sed "s/,/\./"|sort -t'.' -n -k1,1 -k2,2 -k3,3 -k4,4|sed "s/\./,/4"
  else
    cat ${DIR}/*.txt|awk -F: '{val[$4]+=$9} END {for(id in val) print id","val[id]}'|sort -t',' -n -r -k 2 
  fi
fi
